/**********************************************************************
**
** Copyright (C) 2003 Germain Garand <germain@ebooksfrance.org>
**
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**********************************************************************/

#include "actioninterfaceimpl.h"
#include "perlaction.h"

ActionInterfaceImpl::ActionInterfaceImpl() : dIface(0)
{

}

ActionInterfaceImpl::~ActionInterfaceImpl()
{
    if ( dIface )
	dIface->release();
}

QRESULT ActionInterfaceImpl::queryInterface( const QUuid &uuid, QUnknownInterface** iface )
{
    *iface = 0;
    if ( uuid == IID_QUnknown )
	*iface = (QUnknownInterface*)this;
    else if ( uuid == IID_Action )
	*iface = (ActionInterface*)this;
    else if ( uuid == IID_QFeatureList )
	*iface = (QFeatureListInterface*)this;
    else
	return QE_NOINTERFACE;

    (*iface)->addRef();
    return QS_OK;
}

QAction* ActionInterfaceImpl::create( const QString &name, QObject* parent )
{
    if( name == "ExecPerlProject" )
    {
	return new PerlAction( parent, dIface, PerlAction::RunProject );
    }
    else
	return new PerlAction( parent, dIface, PerlAction::RunForm );
}

QStringList ActionInterfaceImpl::featureList() const
{
    QStringList f;
    f << "ExecPerlProject" << "ExecCurrentPerlForm";
    return f;
}
