
#include "languageinterfaceimpl.h"

class PreferenceInterfaceImpl;
class ProjectSettingsInterfaceImpl;
class ClassBrowserInterfaceImpl;
class EditorInterfaceImpl;
class SourceTemplateInterfaceImpl;

class CommonInterface : public QComponentInformationInterface
{
public:
    CommonInterface();
    virtual ~CommonInterface();

    QRESULT queryInterface( const QUuid&, QUnknownInterface** );
    Q_REFCOUNT;

    QString name() const { return "Perl"; }
    QString description() const { return "PerlQt Integration"; }
    QString version() const { return "0.9.2"; }
    QString author() const { return "Germain Garand<germain@ebooksfrance.org>"; }

private:
    LanguageInterfaceImpl *langIface;
    PreferenceInterfaceImpl *prefIface;
    ProjectSettingsInterfaceImpl *proIface;
    ClassBrowserInterfaceImpl * cbrowsIface;
    SourceTemplateInterfaceImpl *srcIface;

};
