#ifndef PQTAPIPROCESS_H
/**********************************************************************
**
** Copyright (C) 2003 Germain Garand <germain@ebooksfrance.org>
**
**
** This file may be distributed and/or modified under the terms of the
** GNU General Public License version 2 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.
**
**********************************************************************/
#define PQTAPIPROCESS_H

#include <qprocess.h>
#include <qasciidict.h>

class QStringList;

class PqtApiProcess: public QProcess
{
    Q_OBJECT

public:
    static PqtApiProcess* instance();
    static bool canRun(){ return canrun; }
    QStringList* request( const QString& classname );
protected:
    PqtApiProcess( const QStringList &lst );
    ~PqtApiProcess();
protected slots:
    void readFuncList();
private:
    bool startFuncList();
    QAsciiDict<QStringList> m_cache;
    QStringList *m_funclist;
    bool m_gotstart;
    bool m_finished;
    static PqtApiProcess *pqtapi;
    static bool canrun;
};

#endif
