/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/

#include <qregexp.h>

void SlotFuncDia::init()
{
    fw = 0;
    dIface = 0;
}

void SlotFuncDia::setInterfaces( DesignerFormWindow * dfw, DesignerInterface* di )
{
    fw = dfw;
    dIface = di;
}

QString SlotFuncDia::cleanArgs( const QString &func )
{
    QString slot( func );
    int begin = slot.find( "(" ) + 1;
    QString args = slot.mid( begin );
    args = args.left( args.find( ")" ) );
    QStringList lst = QStringList::split( ',', args );
    QString res = slot.left( begin );
    for ( QStringList::Iterator it = lst.begin(); it != lst.end(); ++it ) {
        if ( it != lst.begin() )
            res += ",";
        QString arg = *it;
        int pos = 0;
        if ( ( pos = arg.find( "&" ) ) != -1 ) {
            arg = arg.left( pos + 1 );
        } else if ( ( pos = arg.find( "*" ) ) != -1 ) {
            arg = arg.left( pos + 1 );
        } else {
            arg = arg.simplifyWhiteSpace();
            if ( ( pos = arg.find( ':' ) ) != -1 )
                arg = arg.left( pos ).simplifyWhiteSpace() + ":" + arg.mid( pos + 1 ).simplifyWhiteSpace();
            QStringList l = QStringList::split( ' ', arg );
            if ( l.count() == 2 ) {
                if ( l[ 0 ] != "const" && l[ 0 ] != "unsigned" && l[ 0 ] != "var" )
                    arg = l[ 0 ];
            } else if ( l.count() == 3 ) {
                arg = l[ 0 ] + " " + l[ 1 ];
            }
        }
        res += arg;
    }
    res += ")";

    return QString::fromLatin1( QObject::normalizeSignalSlot( res.latin1() ) );
}


static QString make_func_pretty( const QString &s )
{
    QString res = s;
    if ( res.find( ")" ) - res.find( "(" ) == 1 )
        return res;
    res.replace( "(", "( " );
    res.replace( ")", " )" );
    res.replace( "&", " &" );
    res.replace( "*", " *" );
    res.replace( ",", ", " );
    res.replace( ":", " : " );
    res = res.simplifyWhiteSpace();
    res.replace( " : : ", "::" );
    return res;
}

void SlotFuncDia::ok_pressed()
{
    if(!fw)
	reject();
    QString funcfull = functionLineEdit->text();
    bool isSlot =  slotRadio->isChecked();
    
    funcfull = funcfull.simplifyWhiteSpace();
    int ix = funcfull.find( "(" );
    
    if( ix != -1 )
    {
	func = funcfull.left( ix );
	args = funcfull.mid( ix );
    }
    else
    {
	func = funcfull;
	args = "()";
    }
    func.replace( QRegExp( "[^a-zA-Z_]+" ), "_" );
    
    QString pretty = cleanArgs( func + args );
    
    fw->addFunction( QCString( pretty.latin1() ), "", "public",
		     (isSlot ? "slot":"function"), "Perl", "void" );
    accept(); 
}


const QString& SlotFuncDia::function()
{
    return func;
}

const QString& SlotFuncDia::arguments()
{
    return args;
}


bool SlotFuncDia::isSlot()
{
    return slotRadio->isChecked();
}


void SlotFuncDia::checkText( const QString &txt )
{
    if( txt.find( QRegExp( "\\(\\s*\\w+") ) != -1 )
    {	    
	if(  functionRadio->isEnabled() )
	{
	    slotRadio->setChecked( true );    
	    functionRadio->setEnabled( false );
	}
    }
    else if( !functionRadio->isEnabled() )
	functionRadio->setEnabled( true );
}
